﻿Public Class Form1
    Private m_apprentice As Inventor.ApprenticeServerComponent
    Private m_camera As Inventor.Camera
    Private m_lastRotation As Double

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        ' Create an instance of Apprentice.
        m_apprentice = New Inventor.ApprenticeServerComponent

        ' Construct the path, which is up two directories from the location of the exe.
        Dim filePath As String = System.Reflection.Assembly.GetExecutingAssembly.Location
        filePath = filePath.Substring(0, filePath.LastIndexOf("\"c))
        filePath = filePath.Substring(0, filePath.LastIndexOf("\"c))
        filePath = filePath.Substring(0, filePath.LastIndexOf("\"c))

        ' Open the specified file.
        Dim appDoc As Inventor.ApprenticeServerDocument = m_apprentice.Open(filePath & "\Engine Case Side.ipt")

        ' Create a camera.
        m_camera = m_apprentice.TransientObjects.CreateCamera

        ' Associate the camera with the part's component definition.
        m_camera.SceneObject = appDoc.ComponentDefinition

        m_camera.Fit()
        m_camera.ApplyWithoutTransition()

        Dim tg As Inventor.TransientGeometry = m_apprentice.TransientGeometry
        m_camera.Eye = tg.CreatePoint(10, 0, 0)
        m_camera.UpVector = tg.CreateUnitVector(0, 1, 0)
        m_camera.Fit()
        m_camera.ApplyWithoutTransition()

        Dim picDisp As stdole.IPictureDisp
        picDisp = m_camera.CreateImage(PictureBox1.Width, PictureBox1.Height)

        ' Return the image.
        PictureBox1.Image = Microsoft.VisualBasic.Compatibility.VB6.IPictureDispToImage(picDisp)

        scrRotate.Enabled = True
        btnStart.Enabled = False
    End Sub

    Private Function GetImage(ByRef InCamera As Inventor.Camera, ByVal RotationAngle As Double) As Image
        ' Convert the rotation angle to radians.
        RotationAngle = (Math.PI / 180.0) * RotationAngle

        Dim tg As Inventor.TransientGeometry = m_apprentice.TransientGeometry

        ' Compute an eye point.
        InCamera.Eye = tg.CreatePoint(10 * Math.Cos(RotationAngle), InCamera.Eye.Y, 10 * Math.Sin(RotationAngle))

        If chkFit.Checked Then
            InCamera.Fit()
        End If

        InCamera.ApplyWithoutTransition()

        ' Create an image.  Can also use SaveAsBitmap to save the image directly to a file in one of several formats.
        Dim picDisp As stdole.IPictureDisp
        picDisp = InCamera.CreateImage(PictureBox1.Width, PictureBox1.Height)

        ' Return the image.
        Return Microsoft.VisualBasic.Compatibility.VB6.IPictureDispToImage(picDisp)
    End Function

    Private Sub scrRotate_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles scrRotate.ValueChanged
        If Not m_camera Is Nothing Then
            PictureBox1.Image = GetImage(m_camera, scrRotate.Value)
            PictureBox1.Refresh()
        End If
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not m_camera Is Nothing Then
            PictureBox1.Image = GetImage(m_camera, scrRotate.Value)
            m_lastRotation = scrRotate.Value
            PictureBox1.Refresh()
        End If
    End Sub
End Class
